require 'yamd'

class HentaiCafePage < PageCrawler
  def image_url
    @parsed_html.at_css('#page img')['src']
  end
end

class HentaiCafeChapter < ChapterCrawler
  def self.page_class
    HentaiCafePage
  end

  def pages_info
    # there's no need of an lazy enumerator here, no IO action is taken
    page_list = @parsed_html.at_css('ul.dropdown').css('li')
    page_urls = []
    page_list.each do | li_el |
      page_urls << { url: li_el.css('a').first['href'] }
    end
    page_urls
  end

  def name
    @custom_data[:name]
  end
end

class HentaiCafeCrawler < MangaCrawler
  def self.chapter_class
    HentaiCafeChapter
  end

  def chapters_info
    css = 'a.x-btn.x-btn-flat.x-btn-rounded.x-btn-large'
    [{ name: 'OnlyChapter',
      url: @parsed_html.at_css(css)['href'] }]
  end

  def name
    @parsed_html.at_css('h3').text.strip
  end
end

